program UniComm;
uses crt,dos,Userielb,Useriell;
Const MaxMist=3;
Type TMist=array[1..maxmist] of string[3];
     Tgef=array[1..maxmist] of byte;
const mist:TMist=(#27'G0',#27'T',#27'[');
      briefende='@@@';
      bufsize=1024;
      ircfilter=true;

type PKnoten=^TKnoten;
     TKnoten=object
       w:word;
       next,prev:PKnoten;
     end;
     PStack=^TStack;
     TStack=object
       AktKnoten:PKnoten;
       constructor init;
       destructor done;
       procedure push(w:word);
       function pop:word;
     end;

     PMyseriell=^TMyseriell;
     TMySeriell=object(Tseriell)
       aktname:string;
       svar:array['A'..'Z'] of string;
       ivar:array['A'..'Z'] of integer;
       aktzeile:word;
       Stack:PStack;
       parametergesetzt:boolean;
       log,old,snd,nam,logall:text;
       logbuf,nambuf,sndbuf,oldbuf:pointer;
       logoffen:boolean;
       sndoffen:boolean;
       namoffen:boolean;
       oldoffen:boolean;
       sndline:word;
       logalloffen:boolean;
       {lastCR:boolean;}
       LocalEcho:boolean;
       Echo:boolean;
       filterbuf:string;
       ansisequenz:boolean;
       gef:Tgef;
       constructor init;
       destructor done;
       procedure setparams(icom,params,itimeout:byte;agepuffert:boolean);
       procedure closefiles;
       procedure sende(c:char); virtual;
       procedure empfange(var c:char;var stat:byte); virtual;
       procedure fehler(s:string);
       procedure Interpretiere(s:string);
       function miniterm:boolean;
       procedure swrite(s:string); virtual;
       function readsnd:string;
       procedure getadress(var nextadress:string);
       procedure setname(neuname:string);
     end;

var myseriell:PMyseriell;
    oldex:pointer;
    out:text;

function fileexist(name:string):boolean;
var search:searchrec;
begin
  search.name:=name;
  findfirst(name,anyfile,search);
  fileexist:=doserror=0;
end;

procedure myex;far;
begin
  nosound;
  exitproc:=oldex;
  if myseriell<>nil then dispose(myseriell,done);
end;

constructor TStack.init;
begin
  aktknoten:=nil;
end;

destructor TStack.done;
begin
  while aktknoten<>nil do pop;
end;

procedure TStack.push(w:word);
var hknoten:pknoten;
begin
  new(hknoten);
  hknoten^.w:=w;
  hknoten^.prev:=aktknoten;
  if aktknoten<>nil then aktknoten^.next:=hknoten;
  aktknoten:=hknoten;
end;

function TStack.pop:word;
var hknoten:pknoten;
begin
  if aktknoten<>nil then begin
    pop:=aktknoten^.w;
    hknoten:=aktknoten;
    aktknoten:=hknoten^.prev;
    dispose(hknoten);
  end else pop:=0;
end;

procedure tmyseriell.closefiles;
var alt:file;
    suche:searchrec;
begin
  if logoffen then close(log);
  if namoffen then close(nam);
  if oldoffen then close(old);
  if sndoffen then begin
    close(snd);
    findfirst(aktname+'.SND',anyfile,suche);
    if suche.size<>5 then begin
      if fileexist(aktname+'.AL2') then begin
        assign(alt,aktname+'.AL2');
        erase(alt);
      end;
      if fileexist(aktname+'.ALT') then begin
        assign(alt,aktname+'.ALT');
        rename(alt,aktname+'.AL2');
      end;
      rename(snd,aktname+'.ALT');
      assign(snd,aktname+'.SND');
      rewrite(snd);
      writeln(snd,briefende);
      close(snd);
    end;
  end;
  logoffen:=false;
  namoffen:=false;
  oldoffen:=false;
  sndoffen:=false;
end;

constructor tmyseriell.init;
var n:char;
begin
  new(stack,init);
  parametergesetzt:=false;
  logoffen:=false;
  namoffen:=false;
  oldoffen:=false;
  sndoffen:=false;
  logalloffen:=false;
  {lastCR:=false;}
  sndline:=0;
  LocalEcho:=false;
  Echo:=false;
  filterbuf:='';
  fillchar(gef,sizeof(gef),#0);
  ansisequenz:=false;
  aktzeile:=0;
  for n:='A' to 'Z' do begin
    svar[n]:='';
    ivar[n]:=0;
  end;
end;

function tmyseriell.readsnd:string;
var h:string;
begin
  if sndoffen then begin
    readln(snd,h);
    inc(sndline);
  end else begin
    h:='';
    fehler('SETNAME nicht aufgerufen');
  end;
  readsnd:=h;
end;

destructor tmyseriell.done;
begin
  dispose(stack,done);
  closefiles;
  if logalloffen then close(logall);
  close(out);
end;

procedure tmyseriell.swrite(s:string);
begin
  if logalloffen then write(logall,'>>>'+s+'<<<');
  Tseriell.swrite(s);
end;

procedure TMyseriell.setparams(icom,params,itimeout:byte;agepuffert:boolean);
begin
  parametergesetzt:=true;
  TSeriell.init(icom,params,itimeout,agepuffert);
end;

procedure tmyseriell.sende(c:char);

  procedure printdirect(c:char);
  begin
    {if (c=#13) or (c=#10) then begin
      if not lastcr then begin
        lastcr:=true;
        writeln;
        if logalloffen then writeln(logall);
      end;
    end else begin
      lastcr:=false;}
      write(c);
      if logalloffen then system.write(logall,c);
    {end;}
  end;

begin
  tseriell.sende(c);
  if localecho then begin
    textcolor(green);
    printdirect(c);
  end;
end;

procedure tmyseriell.empfange(var c:char;var stat:byte);

  procedure filter(c:char);
  var n,h,x1,x2:byte;
      nichtsgefunden:boolean;
      err:integer;

    procedure verschiebe;
    var x,y:byte;
    begin
      x:=wherex;
      y:=wherey;
      gotoxy(1,1);
      delline;
      gotoxy(x1,x2);
      insline;
      gotoxy(x,y);
    end;

    procedure loesche;
    var x,y:byte;
    begin
      x:=wherex;
      y:=wherey;
      gotoxy(x1,x2);
      clreol;
      gotoxy(x,y);
    end;

  begin
    filterbuf:=filterbuf+c;
    if ansisequenz then begin
      if upcase(c) in ['A'..'Z'] then begin
        ansisequenz:=false;
        nichtsgefunden:=false;
        h:=pos(';',filterbuf);
        if (c='r') and (h<>0) then begin
          delete(filterbuf,length(filterbuf),1);
          val(copy(filterbuf,1,pred(h)),x1,err);
          val(copy(filterbuf,succ(h),255),x2,err);
          if x2=22 then verschiebe
          else if x2=24 then {loesche};
        end else begin
          filterbuf:=#27'['+filterbuf;
          nichtsgefunden:=true;
        end;
      end else nichtsgefunden:=false;
    end else begin
      nichtsgefunden:=true;
      for n:=1 to maxmist do begin
        if mist[n][succ(gef[n])]=c then begin
          inc(gef[n]);
          nichtsgefunden:=false;
        end else gef[n]:=0;
        if gef[n]=length(mist[n]) then begin
          if n=3 then begin
            if ircfilter then begin
              ansisequenz:=true;
              filterbuf:='';
              fillchar(gef,sizeof(gef),#0);
            end else nichtsgefunden:=true;
          end else begin
            filterbuf:='';
            fillchar(gef,sizeof(gef),#0);
          end;
        end;
      end;
    end;
    if nichtsgefunden then begin
      for n:=1 to length(filterbuf) do write(out,filterbuf[n]);
      filterbuf:='';
    end;
  end;

begin
  tseriell.empfange(c,stat);
  textcolor(yellow);
  if (stat and stTimeOut)=0 then begin
    filter(c);
    if logalloffen then write(logall,c);
  end;
end;

procedure leerweg(var s:string);
begin
  while pos(' ',s)=1 do delete(s,1,1);
  while (length(s)>0) and (s[length(s)]=' ') do delete(s,length(s),1);
end;

procedure upstring(var s:string);
var n:byte;
begin
  for n:=1 to length(s) do begin
    s[n]:=upcase(s[n]);
  end;
end;

procedure TMySeriell.setname(neuname:string);
begin
  closefiles;
  aktname:=neuname;
  assign(log,aktname+'.LOG');
  settextbuf(log,logbuf^,bufsize);
  if fileexist(aktname+'.LOG') then append(log) else rewrite(log);
  logoffen:=true;
  assign(NAM,aktname+'.NAM');
  settextbuf(NAM,NAMbuf^,bufsize);
  if not fileexist(aktname+'.NAM') then begin
    rewrite(NAM);
    writeln(nam);
    close(nam);
  end;
  reset(NAM);
  NAMoffen:=true;
  assign(old,aktname+'.OLD');
  settextbuf(old,oldbuf^,bufsize);
  if fileexist(aktname+'.OLD') then append(old) else rewrite(old);
  oldoffen:=true;
  assign(snd,aktname+'.SND');
  sndline:=0;
  if not fileexist(aktname+'.SND') then begin
    rewrite(snd);
    writeln(snd,briefende);
    close(snd);
  end;
  settextbuf(snd,sndbuf^,bufsize);
  reset(snd);
  sndoffen:=true;
end;

procedure NewLn;
begin
  if wherex<>1 then writeln;
end;

procedure tmyseriell.getadress(var nextadress:string);
var h,nick,z:string;
    p:byte;
begin
  if not namoffen then begin
    repeat
      write('Gebe Namesdateiname ein (ohne Erweiterung):');
      readln(z);
    until fileexist(z+'.NAM');
    setname(z);
  end;
  while pos('@',nextadress)=0 do begin
    close(nam);
    reset(nam);
    h:=nextadress;
    leerweg(h);
    upstring(h);
    if h<>'' then begin
      nick:='';
      while (not eof(nam)) and (nick<>h) do begin
        readln(nam,z);
        p:=pos(':',z);
        if p<>0 then begin
          nick:=copy(z,1,pred(p));
          leerweg(nick);
          upstring(nick);
        end;
      end;
    end else nick:='$';
    if nick<>h then begin
      NewLn;
      textcolor(lightred);
      if h<>'' then writeln('Nickname '+h+' nicht gefunden');
      write('Bitte InterNet-Adresse oder Nickname angeben:');
      readln(nextadress);
    end else begin
      nextadress:=copy(z,succ(p),255);
      leerweg(nextadress);
      p:=pos(' ',nextadress);
      if p<>0 then nextadress:=copy(nextadress,1,pred(p));
    end;
  end;
end;

function tmyseriell.miniterm:boolean;
var ein,c:char;
    ende,st,x,y:byte;
    name,h:string;
const F1=59;F2=60;F3=61;F4=62;F5=63;F6=64;F7=65;F8=66;F9=67;F10=68;

  procedure sendefile(name:string);
  var t:text;
      buf:string;
  begin
    assign(t,name);
    reset(t);
    while (not eof(t)) do begin
      readln(t,buf);
      swrite(buf+'^M');
      while (not gepuffert) or (gepuffert and bufvoll) do empfange(c,st);
    end;
  end;

  procedure help;
  begin
    textcolor(red);
    NewLn;
    writeln('F1 HelpF2 ClearF3 FlushF4 NameF5 SendFileF6 EchoF9 ContinueF10 End');
  end;

begin
  if logoffen then flush(log);
  if oldoffen then flush(old);
  if logalloffen then write(logall,'*MiniTermAnfang*');
  miniterm:=true;
  textcolor(red);
  NewLn;
  if parametergesetzt then begin
    writeln('MiniTerminal aktiviert');
    help;
    ende:=0;
    repeat
      repeat
        if (not gepuffert) or (gepuffert and bufvoll)
        then empfange(c,st);
      until keypressed;
      ein:=readkey;
      if (ein=#0) and keypressed then begin
        ein:=readkey;
        case byte(ein) of
          F1:help;
          F2:clrscr;
          F3:begin
            if logoffen then flush(log);
            if oldoffen then flush(old);
          end;
          F4:begin
            h:='';
            getadress(h);
            swrite(h+'^M');
          end;
          F5:begin
            textcolor(lightgray);
            writeln;
            write('Dateiname: ');
            readln(name);
            if fileexist(name) then sendefile(name);
          end;
          F6:begin
            localecho:=not localecho;
            textcolor(lightgray);
            x:=wherex;y:=wherey;
            gotoxy(1,1);
            writeln('Lokales Echo: ',localecho,' ');
            gotoxy(x,y);
          end;
          F9:ende:=2;
          F10:begin
            textcolor(lightgray);
            writeln;
            write('Wirklich abbrechen? (J/N)');
            ein:=' ';
            repeat
              if keypressed then ein:=upcase(readkey);
            until ein in ['J','N'];
            if ein='J' then ende:=1;
          end;
        end;
      end else sende(ein);
    until ende<>0;
    miniterm:=ende<>1;
  end else miniterm:=false; {false=ende, true=weiter}
  if logalloffen then write(logall,'-MiniTermEnde-');
end;

procedure tmyseriell.fehler(s:string);
var ein,c:char;
    ende,st,x,y:byte;
const F1=59;F2=60;F3=61;F10=68;
begin
  NewLn;
  textcolor(red);
  if s<>'' then writeln(s+^G+' in Zeile ',aktzeile);
  if (not parametergesetzt) or (parametergesetzt and (not miniterm))
  then  halt(1);
end;

procedure tmyseriell.Interpretiere(s:string);
var search:searchrec;
    scr:text;
    scrbuf:pointer;
    scrsize:word;
    nextadress,buf,befehl,argumente,param,name:string;
    l,par:byte;
    scrende,ende:boolean;

  function fupstring(s:string):string;
  var n:byte;
      h:string;
  begin
    h:='';
    for n:=1 to length(s) do begin
      h:=h+upcase(s[n]);
    end;
    fupstring:=h;
  end;

  function getparam:string;
  begin
    while pos(' ',argumente)=1 do delete(argumente,1,1);
    argumente:=argumente+' ';
    getparam:=copy(argumente,1,pred(pos(' ',argumente)));
    argumente:=copy(argumente,succ(pos(' ',argumente)),255);
  end;

  function getstring:string;
  var s2,s,i:string;
      nummer:char;
      h:byte;
  begin
    getstring:='';
    leerweg(argumente);
    if argumente[1]='$' then begin
      delete(argumente,1,1);
      nummer:=upcase(argumente[1]);
      delete(argumente,1,1);
      if (nummer>'Z') or (nummer<'A') then fehler('Fehlerhafte Variable')
      else getstring:=svar[nummer];
    end else if argumente[1]='"' then begin
      delete(argumente,1,1);
      l:=pos('"',argumente);
      if l=0 then fehler('Kein 2." in: '+buf);
      s:=copy(argumente,1,pred(l));
      argumente:=copy(argumente,succ(l),255);
      while pos('$',s)<>0 do begin
        l:=pos('$',s);
        if length(s)<succ(l) then fehler('Variablenname erwartet');
        nummer:=upcase(s[succ(l)]);
        if (nummer>'Z') or (nummer<'A') then begin
          if nummer='$' then delete(s,l,1)
          else fehler('Fehlerhafte Variable')
        end else s:=copy(s,1,pred(l))+svar[nummer]+copy(s,l+2,255);
      end;
      h:=pos('^',s);
      s2:='';
      while h<>0 do begin
        s2:=s2+copy(s,1,pred(h));
        delete(s,1,h);
        if s[1]<>'^' then s[1]:=char(byte(upcase(s[1]))-byte(pred('A')));
        h:=pos('^',s);
      end;
      s2:=s2+s;
      getstring:=s2;
    end else begin
      s:=fupstring(getparam);
      if s='READSND' then begin
        getstring:=readsnd;
      end else if s='READCON' then begin
        textcolor(red);
        NewLn;
        write(getstring);
        readln(i);
        getstring:=i;
      end else if s='READCOM' then
        getstring:=readcom
      else  fehler('Kein " oder $ in: '+buf);
    end;
  end;

  procedure neuezeile;

    procedure lies;
    begin
      repeat
        if not eof(scr) then readln(scr,buf)
        else fehler('Unerwartetes Ende des Programms');
        leerweg(buf);
        inc(aktzeile);
      until eof(scr) or (buf<>'');
      if echo then begin
        textcolor(lightmagenta);
        NewLn;
        writeln(buf);
      end;
    end;

  begin
    lies;
    while buf[1]='{' do begin
      while not ((pos('}',buf)<>0) or eof(scr)) do lies;
      if eof(scr) then fehler('{ ohne } im Script!');
      lies;
    end;
  end;


  procedure intwrite;
  var nummer:char;
      buf:string;
  begin
    if (pos('"',copy(argumente,succ(pos('"',argumente)),255))<>0) or (pos('$',argumente)<>0)
    then swrite(getstring) else begin
      l:=pos('"',buf);
      if l=0 then begin
        nummer:=upcase(argumente[1]);
        delete(argumente,1,1);
        if (nummer>'Z') or (nummer<'A')
        then fehler('Fehlerhafte Variable');
        str(ivar[nummer],buf);
        swrite(buf);
      end else begin
        buf:=copy(buf,succ(l),255);
        ende:=false;
        repeat
          l:=pos('"',buf);
          if l<>0 then begin
            ende:=true;
            buf:=copy(buf,1,pred(l));
          end;
          swrite(buf);
          if not ende then neuezeile;
        until eof(scr) or ende;
      end;
    end;
  end;

  procedure jump(marke:string);
  var n:byte;
      gef:boolean;
      a:word;
  begin
    a:=aktzeile;
    upstring(marke);
    close(scr);
    reset(scr);
    aktzeile:=0;
    gef:=false;
    while (not eof(scr)) and (not gef) do begin
      readln(scr,buf);
      inc(aktzeile);
      leerweg(buf);
      if (length(buf)>0) and (buf[1]=':') then begin
        upstring(buf);
        gef:=marke=buf;
      end;
    end;
    if eof(scr) then begin
      aktzeile:=a;
      fehler('GOTO Label nicht gefunden');
    end;
  end;

  procedure warteauf;
  var buf:string;
  begin
    if waitfor(getstring)=erTimeOut then begin
      buf:=getstring;
      if buf[1]=':' then jump(buf) else fehler(buf);
    end else getstring;
  end;

  procedure writewait;
  begin
    intwrite;
    warteauf;
  end;

  procedure ifparam;
  var n:byte;
      gef:boolean;
  begin
    upstring(argumente);
    param:=getstring;
    gef:=false;
    for n:=1 to paramcount do begin
      gef:=gef or (fupstring(paramstr(n))=param);
    end;
    if not gef then argumente:='';
  end;

  procedure ifadress;
  var gef:boolean;
      h:string;
  begin
    nextadress:='';
    gef:=false;
    while (not eof(snd)) and (not gef) do begin
      readln(snd,h);
      inc(sndline);
      if (h<>briefende) or (sndline<>1) then writeln(old,h);
      if (length(h)>0) and (h[1]=':') then begin
        nextadress:=copy(h,2,255);
        getadress(nextadress);
        gef:=true;
      end;
    end;
    h:=getparam;
    if gef then jump(h);
  end;

  
  procedure sendadress;
  begin
    if nextadress<>'' then swrite(nextadress)
    else fehler('Keine Adresse mehr da');
    nextadress:='';
  end;

  procedure receiveorsearch(loggen:boolean);
  var h,s:string;
      nummer:char;
      SList:TStringList;
      nr,l:byte;
  begin
    h:=getparam;
    nummer:=upcase(h[1]);
    if (nummer>'Z') or (nummer<'A') then fehler('Fehlerhafte Variable');
    fillchar(slist,sizeof(slist),#0);
    nr:=0;
    s:=argumente;
    l:=pos('"',s);
    while l<>0 do begin
      inc(nr);
      delete(s,1,l);
      l:=pos('"',s);
    end;
    if nr<>0 then begin
      for l:=1 to pred(nr div 2) do slist[l]:=getstring;
      ivar[nummer]:=readtofile(log,slist,pred(nr div 2),loggen);
      h:=getstring;
      if (ivar[nummer]=0) and (h<>'') then fehler(h);
    end else ivar[nummer]:=0;
  end;

  procedure sendedatei;
  var weiter:boolean;
      buf:string;
      c:char;
      st:byte;
  begin
    weiter:=true;
    while (not eof(snd)) and weiter do begin
      readln(snd,buf);
      inc(sndline);
      writeln(old,buf);
      if copy(buf,1,length(briefende))=briefende then weiter:=false
      else begin
        swrite(buf+'^M');
        while (not gepuffert) or (gepuffert and bufvoll) do empfange(c,st);
      end
    end;
  end;

  procedure sendline;
  var buf:string;
  begin
    if (not eof(snd)) then begin
      readln(snd,buf);
      inc(sndline);
      writeln(old,buf);
      swrite(buf);
    end else fehler('Keine Zeile zum Senden');
  end;

  procedure openlogall;
  var search:searchrec;
      param:string;
  begin
    param:=fupstring(getparam);
    if param='CLOSE' then begin
      if logalloffen then begin
        close(logall);
        logalloffen:=false;
      end;
    end else begin
      assign(logall,'UNICOMM.LOG');
      search.name:='UNICOMM.LOG';
      findfirst('UNICOMM.LOG',anyfile,search);
      if (doserror<>0) or (param='NEW') then rewrite(logall)
      else begin
        append(logall);
        if param='OLD' then begin
          writeln(logall);
          writeln(logall,'--------  New Session  --------');
          writeln(logall);
        end;
      end;
      logalloffen:=true;
    end;
  end;

  function calculate(s:string):real;
  var buf,hilf:string;
      intzahl:boolean;
      n:byte;
      funk:shortint;

    Function berechne(f:string;x,y:real):real;
    const klammer=true;
          glied=false;
          maxreal=1.7e38;
          plus=0;
          minus=1;
          geteilt=2;
          mal=3;
          nichts=4;
    var hilfb,aktpos:byte;
        err2,err:integer;
        hilf:real;
        funkt:string[6];
        modus:boolean;

      Function rechne(sinn:boolean):real;
      var z,stapel:real;
          vorprodukt,vorganger:byte;

      procedure error;
      begin
        fehler(copy(f,1,aktpos)+'_'+copy(f,succ(aktpos),length(f)-aktpos));
      end;

      begin
        while (pos(' ',f)=aktpos) and (aktpos<=length(f)) do inc(aktpos);
        if aktpos>length(f) then error;
        if ((f[aktpos]='[') or (f[aktpos]='{') or (f[aktpos]='(')) then begin
          inc(aktpos);
          z:=rechne(klammer)
        end else begin
          funkt:='';
          while (f[aktpos]>='A') and (f[aktpos]<='Z') do begin
            funkt:=funkt+f[aktpos];
            inc(aktpos);
          end;
          if length(funkt)<>0 then begin
            if funkt='Y' then z:=y else
            if funkt='X' then z:=x else
            if funkt='E' then z:=2.718281829 else
            if funkt='PI' then z:=pi else
            if funkt='RND' then z:=random else
            if funkt='LN' then begin
              inc(aktpos);
              hilf:=rechne(klammer);
              if hilf<=0 then error;
              z:=ln(hilf);
            end else if funkt='EXP' then begin
              inc(aktpos);
              z:=exp(rechne(klammer));
            end else if funkt='SIN' then begin
              inc(aktpos);
              z:=sin(rechne(klammer));
            end else if funkt='COS' then begin
              inc(aktpos);
              z:=cos(rechne(klammer));
            end else if funkt='TAN' then begin
              inc(aktpos);
              hilf:=rechne(klammer);
              z:=sin(hilf);
              hilf:=cos(hilf);
              if hilf<>0 then z:=z/hilf else z:=maxreal;
            end else if funkt='COT' then begin
              inc(aktpos);
              hilf:=rechne(klammer);
              z:=cos(hilf);
              hilf:=sin(hilf);
              if hilf<>0 then z:=z/hilf else z:=maxreal;
            end else if funkt='ABS' then begin
              inc(aktpos);
              z:=abs(rechne(klammer));
            end else if funkt='SGN' then begin
              inc(aktpos);
              hilf:=rechne(klammer);
              if hilf<0 then z:=-1 else if z>0 then z:=1 else z:=0;
            end else if funkt='SQR' then begin
              inc(aktpos);
              z:=sqr(rechne(klammer));
            end else if funkt='SQRT' then begin
              inc(aktpos);
              hilf:=rechne(klammer);
              if hilf<0 then error;
              z:=sqrt(hilf);
            end else if funkt='FRAC' then begin
              inc(aktpos);
              z:=frac(rechne(klammer));
            end else if funkt='TRUNC' then begin
              inc(aktpos);
              z:=trunc(rechne(klammer));
            end else if funkt='ROUND' then begin
              inc(aktpos);
              z:=round(rechne(klammer));
            end else if funkt='ARCTAN' then begin
              inc(aktpos);
              z:=arctan(rechne(klammer));
            end else error;
          end else begin
            val(copy(f,aktpos,length(f)-pred(aktpos)),z,err);
            if err=1 then error;
            if err=0 then aktpos:=length(f) else begin
              val(copy(f,aktpos,pred(err)),z,err2);
              aktpos:=aktpos+pred(err);
            end;
          end;
        end;
        if sinn=klammer then begin
          vorganger:=nichts; stapel:=0;
          while ((f[aktpos]<>']') and (f[aktpos]<>'}') and
                 (f[aktpos]<>')') and (aktpos<length(f))) do begin
            hilfb:=aktpos;
            inc(aktpos);
            if ((f[aktpos]='[') or (f[aktpos]='{') or (f[aktpos]='(')) then begin
              inc(aktpos);
              modus:=klammer;
            end else modus:=glied;
            case f[hilfb] of
              '+':begin
                    case vorganger of
                      plus,nichts: begin z:=z+stapel; stapel:=rechne(modus); end;
                      minus: begin z:=z-stapel; stapel:=rechne(modus); end;
                      mal,geteilt:
                      case vorprodukt of
                        plus: begin z:=z+stapel; stapel:=rechne(modus); end;
                        minus: begin z:=z-stapel; stapel:=rechne(modus); end;
                        nichts: begin z:=stapel; stapel:=rechne(modus); end;
                      end;
                    end;
                    vorganger:=plus;
                  end;
              '-':begin
                    case vorganger of
                      plus,nichts: begin z:=z+stapel; stapel:=rechne(modus); end;
                      minus: begin z:=z-stapel; stapel:=rechne(modus); end;
                      mal,geteilt: case vorprodukt of
                        plus: begin z:=z+stapel; stapel:=rechne(modus); end;
                        minus: begin z:=z-stapel; stapel:=rechne(modus); end;
                        nichts: begin z:=stapel; stapel:=rechne(modus); end;
                      end;
                    end;
                    vorganger:=minus;
                  end;
              '/':begin
                    hilf:=rechne(modus);
                    if vorganger=nichts then stapel:=z;
                    if (vorganger=minus) or (vorganger=plus) or
                       (vorganger=nichts) then vorprodukt:=vorganger;
                    if hilf<>0 then stapel:=stapel/hilf else stapel:=maxreal;
                    vorganger:=geteilt;
                  end;
              '*':begin
                    if vorganger=nichts then stapel:=z;
                    if (vorganger=minus) or (vorganger=plus) or
                       (vorganger=nichts) then vorprodukt:=vorganger;
                    stapel:=stapel*rechne(modus);
                    vorganger:=mal;
                  end;
              else error;
            end;
          end;
          case vorganger of
            plus:   z:=z+stapel;
            minus:  z:=z-stapel;
            geteilt,mal:case vorprodukt of
                  plus:  z:=z+stapel;
                  minus: z:=z-stapel;
                  nichts:z:=stapel;
                end;
          end;
          inc(aktpos);
        end;
        rechne:=z;
      end;

    begin
      for aktpos:=1 to length(f) do begin
        f[aktpos]:=upcase(f[aktpos]);
      end;
      aktpos:=1;
      berechne:=rechne(klammer);
    end;


    function gleich(bef,s:string):boolean;
    var glei:boolean;
        n,k:byte;
    begin
      glei:=true;
      while (' '=bef[length(bef)]) do delete(bef,length(bef),1);
      K:=length(bef);
      n:=length(s);
      if n<>k then begin
        gleich:=false;
        exit;
      end;
      n:=1;
      repeat
        bef[n]:=upcase(bef[n]);
        case bef[n] of
          '':bef[n]:='';
          '':bef[n]:='';
          '':bef[n]:='';
        end;
        glei:=glei and (s[n]=bef[n]);
        inc(n);
      until (not glei) or (n>k);
      gleich:=glei;
    end;


    procedure datevar(nr:byte);
    var date:array[0..3] of word;
    begin
      funk:=-1;
      getdate(date[0],date[1],date[2],date[3]);
      str(date[nr]:4,buf);
      while pos(' ',buf)=1 do delete(buf,1,1);
      hilf:=hilf+buf;
    end;

    procedure timevar(nr:byte);
    var time:array[0..3] of word;
    begin
      funk:=-1;
      gettime(time[0],time[1],time[2],time[3]);
      str(time[nr]:2,buf);
      while pos(' ',buf)=1 do delete(buf,1,1);
      hilf:=hilf+buf;
    end;

    procedure setvar(v:real);
    begin
      funk:=-1;
      str(v:10,buf);
      while pos(' ',buf)=1 do delete(buf,1,1);
      hilf:=hilf+buf;
    end;

  begin
    hilf:='';
    if pos(' ',s)<>0 then s:=copy(s,1,pred(pos(' ',s)));
    intzahl:=false;
    for n:=1 to length(s) do begin
      if (s[n]<>'') and ((upcase(s[n])<'A') or (upcase(s[n])>'Z')) then hilf:=hilf+s[n] else begin
        if s[n]='' then intzahl:=true else begin
          if intzahl then setvar(ivar[upcase(s[n])])
          else begin
            funk:=0;
            if pos('(',copy(s,n,255))<>0 then begin
              buf:=copy(s,n,pred(pos('(',copy(s,n,succ(length(s)-n)))));
              if ((length(buf)=2) and gleich(buf,'LN')) or
                 ((length(buf)=3) and ((gleich(buf,'EXP') or
                 gleich(buf,'SIN') or gleich(buf,'COS') or
                 gleich(buf,'TAN') or gleich(buf,'COT') or
                 gleich(buf,'ABS') or gleich(buf,'SGN') or
                 gleich(buf,'SQR'))) or
                 ((length(buf)=4) and (gleich(buf,'SQRT') or
                 gleich(buf,'FRAC'))) or
                 ((length(buf)=5) and (gleich(buf,'TRUNC') or gleich(buf,'ROUND'))) or
                 ((length(buf)=6) and gleich(buf,'ARCTAN'))) then funk:=length(buf);
            end else if gleich(copy(s,n,2),'PI') then funk:=2 else
            if gleich(copy(s,n,3),'RND') then funk:=3 else
            if gleich(copy(s,n,3),'DAY') then begin datevar(0); inc(n,2); end else
            if gleich(copy(s,n,5),'MONTH') then begin datevar(1); inc(n,4); end else
            if gleich(copy(s,n,4),'YEAR') then begin datevar(2); inc(n,3); end else
            if gleich(copy(s,n,4),'HOUR') then begin timevar(0); inc(n,3); end else
            if gleich(copy(s,n,6),'MINUTE') then begin timevar(1); inc(n,5); end else
            if gleich(copy(s,n,6),'SECOND') then begin timevar(2); inc(n,5); end else
         {   if gleich(copy(s,n,3),'POS') then inc(n,intpos(copy(s,n,255))) else}
            if funk>=0 then begin
              if funk=0 then begin
                str(ivar[upcase(s[n])],buf);
                while pos(' ',buf)=1 do delete(buf,1,1);
                hilf:=hilf+buf;
              end else begin
                hilf:=hilf+copy(s,n,funk);
                inc(n,pred(funk));
              end;
            end;
          end;
          intzahl:=false;
        end;
      end
    end;
    calculate:=berechne(hilf,0,0);
  end;

  procedure intlet;
  var intzahl:boolean;
      nummer:char;
  begin
    intzahl:=argumente[1]<>'$';
    if not intzahl then delete(argumente,1,1);
    nummer:=upcase(argumente[1]);
    if (nummer>'Z') or (nummer<'A')
    then fehler('Fehlerhafte Variable');
    delete(argumente,1,pos('=',argumente));
    while pos(' ',argumente)=1 do delete(argumente,1,1);
    if intzahl then begin
      ivar[nummer]:=round(calculate(getparam));
      delete(argumente,1,pos(' ',argumente));
    end else svar[nummer]:=getstring;
  end;

  function getint:integer;
  begin
    getint:=round(calculate(getparam))
  end;

  procedure wait;
  var n:word;
  begin
    for n:=1 to getint do begin
      delay(1);
      if keypressed then begin
        while keypressed do readkey;
        exit;
      end;
    end;
  end;

  procedure setup;
  var zeit:word;
  begin
    upstring(argumente);
    if getparam='COM2' then com:=com2 else com:=com1;
    param:=getparam;
    if param='9600' then par:=br9600 else
    if param='1200' then par:=br1200 else par:=br2400;
    if getparam='7' then par:=par+bits7 else par:=par+bits8;
    param:=getparam;
    if param='E' then par:=par+even else
    if param='O' then par:=par+odd else par:=par+none;
    if getparam='2' then par:=par+stop2 else par:=par+stop1;
    zeit:=getint;
    setparams(com,par,zeit,getparam='BUFFER');
  end;


  procedure ifinter;
  var entsch,text:boolean;
      a,b:real;
      l,art,elsepos:byte;
      h,tex,s1,s2:string;
  begin
    l:=1;
    while (not (argumente[l] in ['=','>','<'])) and (l<length(argumente)) do inc(l);
    if l=length(argumente) then fehler('< > = <> >= <= erwartet');
    tex:=copy(argumente,1,pred(l));
    if tex[1] in ['$','"'] then begin
      text:=true;
      h:=argumente;
      argumente:=tex;
      s1:=getstring;
      argumente:=h;
    end else begin
      text:=false;
      a:=calculate(tex);
    end;
    delete(argumente,1,pred(l));
    if argumente[1]='>' then art:=1 else
    if argumente[1]='<' then art:=2 else
    if argumente[1]='=' then art:=3;
    if argumente[2]='>' then art:=4 else
    if argumente[2]='=' then inc(art,4);
    delete(argumente,1,1);
    if art>=4 then delete(argumente,1,1);
    while pos(' ',argumente)=1 do delete(argumente,1,1);
    tex:=copy(argumente,1,pos(' ',argumente));
    if text then begin
      h:=argumente;
      argumente:=tex;
      s2:=getstring;
      argumente:=h;
    end else b:=calculate(tex);
    delete(argumente,1,pos(' ',argumente));
    while pos(' ',argumente)=1 do delete(argumente,1,1);
    if text then begin
      if art<7 then begin
        leerweg(s1);
        leerweg(s2);
        upstring(s1);
        upstring(s2);
      end;
      case art of
        1:entsch:=s1>s2;
        2:entsch:=s1<s2;
        3:entsch:=s1=s2;
        4:entsch:=s1<>s2;
        5:entsch:=s1>=s2;
        6:entsch:=s1<=s2;
        else entsch:=s1=s2;
      end;
    end else begin
      case art of
        1:entsch:=a>b;
        2:entsch:=a<b;
        4:entsch:=a<>b;
        5:entsch:=a>=b;
        6:entsch:=a<=b;
        else entsch:=a=b;
      end;
    end;
    upstring(argumente);
    elsepos:=pos('ELSE',argumente);
    if elsepos<>0 then begin
      if entsch then argumente:=copy(argumente,1,pred(elsepos))
      else argumente:=copy(argumente,elsepos+4,length(argumente)-elsepos-3);
    end else begin
      if not entsch then argumente:='';
    end;
  end;

  procedure intgosub;
  begin
    stack^.push(aktzeile);
    jump(getparam);
  end;

  procedure intreturn;
  var z:word;
  begin
    z:=stack^.pop;
    close(scr);
    reset(scr);
    aktzeile:=0;
    while (not eof(scr)) and (aktzeile<z) do begin
      readln(scr,buf);
      inc(aktzeile);
    end;
  end;

  procedure intcase;
  var gef:boolean;
      h,k:byte;
      a:word;
      marke:string;
      sucheend:boolean;
      CaseNr:word;
      zahl:char;
  begin
    marke:=getparam;
    Zahl:=upcase(marke[1]);
    if (zahl>'Z') or (zahl<'A') then fehler('CASE-Anweisung ohne korrekten Parameter');
    casenr:=0;
    a:=aktzeile;
    str(ivar[zahl],marke);
    gef:=false;
    sucheend:=false;
    while (not eof(scr)) and (not gef) do begin
      readln(scr,buf);
      leerweg(buf);
      inc(aktzeile);
      l:=pos(' ',buf);
      if l<>0 then buf:=copy(buf,1,pred(l));
      upstring(buf);
      if buf='CASE' then inc(casenr)
      else if (buf='ENDCASE') then begin
        if (casenr>0) then dec(casenr) else gef:=true;
      end else if casenr=0 then begin
        if sucheend then begin
          sucheend:='END'<>buf
        end else begin
          h:=pos(':',buf);
          if h<>0 then begin
            k:=pos(',',buf);
            while (k<>0) and (not gef) do begin
              gef:=gef or (marke=copy(buf,1,pred(k)));
              delete(buf,1,k);
              k:=pos(',',buf);
            end;
            gef:=gef or (marke=copy(buf,1,pred(pos(':',buf))));
            sucheend:=true;
          end;
          if not gef then gef:='ELSE'=buf;
          if not gef then gef:='ENDCASE'=buf;
        end;
      end;
    end;
    if eof(scr) then begin
      aktzeile:=a;
      fehler('ENDCASE nicht gefunden CASE-Anweisung');
    end;
  end;

  procedure intend;
  var n:byte;
      gef:word;
      h:word;
  begin
    h:=aktzeile;
    gef:=1;
    while (not eof(scr)) and (gef<>0) do begin
      readln(scr,buf);
      inc(aktzeile);
      leerweg(buf);
      upstring(buf);
      if 'ENDCASE'=buf then dec(gef)
      else if 'CASE'=buf then inc(gef);
    end;
    if eof(scr) then begin
      aktzeile:=h;
      fehler('ENDCASE nicht gefunden CASE-Anweisung');
    end;
  end;

  procedure intecho;
  begin
    NewLn;
    textcolor(red);
    writeln(getstring);
  end;

  procedure ring;
  var c:char;
      st:byte;

    procedure peep(a,e:word);
    var z:word;
    begin
      z:=a;
      while (not keypressed) and (z<e) do begin
        delay(1);
        sound(z);
        inc(z);
      end;
      nosound;
    end;

    procedure warte(a:word);
    var z:word;
    begin
      z:=0;
      while (not keypressed) and (z<a) do begin
        delay(1);
        inc(z);
      end;
    end;

  begin
    repeat
      peep(300,600);
      warte(200);
      peep(400,800);
      warte(100);
      peep(500,1000);
      warte(4000);
      if (not gepuffert) or (gepuffert and bufvoll)
      then empfange(c,st);
    until keypressed;
    while keypressed do readkey;
  end;

  function getstringname:char;
  var s:string;
  begin
    s:=getparam;
    if (length(s)<>2) or (not (upcase(s[2]) in ['A'..'Z'])) or (s[1]<>'$')
    then begin
      fehler('Keine StringVariable');
      getstringname:='Z';
    end else getstringname:=upcase(s[2]);
  end;

  function getintname:char;
  var s:string;
  begin
    s:=getparam;
    if (length(s)>1) or (not (upcase(s[1]) in ['A'..'Z'])) then begin
      fehler('Keine IntegerVariable');
      getintname:='Z';
    end else getintname:=upcase(s[1]);
  end;

  procedure intstring;
  var s:char;
      n:integer;
  begin
    s:=getstringname;
    n:=getint;
    str(n,svar[s]);
  end;


  procedure intcopy;
  var s:char;
      s1:string;
      a,c:integer;
  begin
    s:=getstringname;
    s1:=getstring;
    a:=getint;
    c:=getint;
    svar[s]:=copy(s1,a,c);
  end;

  procedure intpos;
  var n:char;
      s1,s2:string;
  begin
    n:=getintname;
    s1:=getstring;
    s2:=getstring;
    ivar[n]:=pos(s1,s2);
  end;

  procedure intconnection;
  var f:file;
      t:text;
      logindt,dt:datetime;
      ftime:longint;
      dow,hund:word;
      mitternacht,dh,dm,ds:integer;
      s:string;
      n:byte;
      c:string[1];

    function tagabstand(d,m,y,vd,vm,vy:integer):integer;
    const mlange:array[1..12] of byte=(31,28,31,30,31,30,31,31,30,31,30,31);
    var h:integer;
    begin
      h:=0;
      while y<vy do begin
        if ((y div 4)=0) and ((y div 200)<>0) then inc(h);
        inc(y);
        inc(h,365);
      end;
      if m<vm then begin
        while m<vm do begin
          inc(h,mlange[m]);
          inc(m);
        end;
      end else begin
        while m>vm do begin
          dec(h,mlange[m]);
          dec(m);
        end;
      end;
      tagabstand:=h+(vd-d);
    end;

  begin
    s:=getparam;
    upstring(s);
    if s='ESTABLISHED' then begin
      assign(f,'LASTCONN.DAT');
      rewrite(f,1);
      with dt do begin
        GetTime(hour,min,sec,hund);
        Getdate(year,month,day,dow);
      end;
      Packtime(dt,ftime);
      blockwrite(f,ftime,sizeof(ftime));
      close(f);
    end else if s='CLOSED' then begin
      with dt do begin
        GetTime(hour,min,sec,hund);
        Getdate(year,month,day,dow);
      end;
      if fileexist('LASTCONN.DAT') then begin
        assign(f,'LASTCONN.DAT');
        reset(f,1);
        blockread(f,ftime,sizeof(ftime));
        unpacktime(ftime,logindt);
        close(f);
        erase(f);
      end else with logindt do begin
        GetTime(hour,min,sec,hund);
        Getdate(year,month,day,dow);
      end;
      assign(t,'CONNECTS.DAT');
      if fileexist('CONNECTS.DAT') then append(t) else rewrite(t);
      with logindt do begin
        if year<100 then begin
          if year>90 then inc(year,1900) else inc(year,2000);
        end;
        mitternacht:=tagabstand(logindt.day,logindt.month,logindt.year,dt.day,dt.month,dt.year);
        year:=round(frac(year/100)*100);
        if paramcount>1 then for n:=2 to paramcount do begin
          c:=copy(paramstr(n),1,1);
          write(t,upcase(c[1]));
        end else write(t,'?');
        write(t,' ',day:2,' ',Month:2,' ',Year:2,' ',mitternacht:1,' ',Hour:2,' ',Min:2,' ',dt.hour:2,' ',dt.min:2);
        ds:=dt.sec-sec;
        if ds<0 then begin
          inc(min);
          ds:=ds+60;
        end;
        dm:=dt.min-min;
        if dm<0 then begin
          inc(hour);
          dm:=dm+60;
        end;
        if year<100 then begin
          if year>90 then inc(year,1900) else inc(year,2000);
        end;
        mitternacht:=tagabstand(logindt.day,logindt.month,logindt.year,dt.day,dt.month,dt.year);
        dh:=dt.hour-hour+24*mitternacht;
        writeln(t,' ',dh,':',dm,':',ds);
      end;
      close(t);
    end else fehler('ESTABLISHED or CLOSED expected');
  end;

begin
  argumente:='';
  getmem(logbuf,bufsize);
  getmem(nambuf,bufsize);
  getmem(oldbuf,bufsize);
  getmem(sndbuf,bufsize);
  nextadress:='';
  search.name:=S+'.UNI';
  findfirst(s+'.UNI',anyfile,search);
  if doserror<>0 then fehler(s+'.UNI nicht gefunden!');
  assign(scr,s+'.UNI');
  if search.size>65535 then scrsize:=65535 else scrsize:=search.size;
  getmem(scrbuf,scrsize);
  settextbuf(scr,scrbuf^,scrsize);
  reset(scr);
  aktzeile:=0;
  scrende:=false;
  while (not eof(scr)) and (not scrende) do begin
    if keypressed then begin
      while keypressed do readkey;
      fehler('');
    end;
    leerweg(argumente);
    if argumente<>'' then buf:=argumente else neuezeile;
    l:=pos(' ',buf);
    if l<>0 then begin
      befehl:=copy(buf,1,pred(l));
      argumente:=copy(buf,succ(l),255);
    end else begin
      befehl:=buf;
      argumente:='';
    end;
    upstring(befehl);
    if befehl[1] in [':',';'] then argumente:=''
    else if befehl='SETUP' then setup
    else if befehl='DELAY' then wait
    else if befehl='WRITE' then intwrite
    else if befehl='WAITFOR' then warteauf
    else if befehl='WRITEWAIT' then writewait
    else if befehl='IFPARAM' then ifparam
    else if befehl='IFADRESS' then ifadress
    else if befehl='GOTO' then jump(getparam)
    else if befehl='SETNAME' then setname(getstring)
    else if befehl='SENDADRESS' then sendadress
    else if befehl='RECEIVE' then receiveorsearch(true)
    else if befehl='SEARCH' then receiveorsearch(false)
    else if befehl='SEND' then sendedatei
    else if befehl='SENDLINE' then sendline
    else if befehl='LOGALL' then openlogall
    else if befehl='TERMINAL' then fehler(getstring)
    else if befehl='STOP' then scrende:=true
    else if befehl='HALFDUPLEX' then localecho:=true
    else if befehl='FULLDUPLEX' then localecho:=false
    else if befehl='TRACE' then echo:=true
    else if befehl='LET' then intlet
    else if befehl='GOSUB' then intgosub
    else if befehl='RETURN' then intreturn
    else if befehl='IF' then ifinter
    else if befehl='CASE' then intcase
    else if befehl='END' then intend
    else if befehl='ENDCASE' then
    else if befehl='WRITELNLOG' then writeln(log,getstring)
    else if befehl='ECHO' then intecho
    else if befehl='CLRSCR' then clrscr
    else if befehl='RING' then ring
    else if befehl='SOUND' then sound(getint)
    else if befehl='NOSOUND' then nosound
    else if befehl='STRING' then intstring
    else if befehl='COPY' then intcopy
    else if befehl='POS' then intpos
    else if befehl='CLOSEFILES' then closefiles
    else if befehl='CONNECTION' then intconnection
    else fehler('Unbekannter Befehl: '+buf);
  end;
  close(scr);
  if logalloffen then close(logall);
  logalloffen:=false;
  freemem(scrbuf,scrsize);
  freemem(logbuf,bufsize);
  freemem(nambuf,bufsize);
  freemem(oldbuf,bufsize);
  freemem(sndbuf,bufsize);
end;

begin
  assign(out,'');
  rewrite(out);
  oldex:=exitproc;
  exitproc:=@myex;
  if paramcount<1 then
    writeln(out,'UniComm [Scriptdatei] [Namenskuerzel]')
  else begin
    textbackground(blue);
    textcolor(lightmagenta);
    clrscr;
    textcolor(white);
    writeln('*** UniComm 1.1   (c) Florian Schreck ***');
    writeln;
    new(myseriell,init);
    myseriell^.Interpretiere(paramstr(1));
    dispose(myseriell,done);
    myseriell:=nil;
  end;
end.