unit useriell;
interface
uses crt,userielb;
const CR=#$0d;
      LF=#$0a;
type TStringList=array[1..20] of string[30];
     TSeriell=object(TSeriellb)
       com,timeout:byte;
       constructor init(icom,params,itimeout:byte;agepuffert:boolean);
       destructor done;
       procedure sende(c:char); virtual;
       procedure empfange(var c:char;var stat:byte); virtual;
       procedure swrite(s:string); virtual;
       function readcom:string;
       function waitfor(s:string):boolean;
       function readtofile(var fil:text;slist:TStringList;anzahl:byte;loggen:boolean):byte;
     end;

const erTimeOut=false;
      erNone=true;


implementation
type TGEF=array[1..20] of byte;

constructor Tseriell.init(icom,params,itimeout:byte;agepuffert:boolean);
begin
  com:=icom;
  Tseriellb.init(com,params,agepuffert);
  timeout:=itimeout;
end;

destructor TSeriell.done;
begin
end;

procedure tseriell.sende(c:char);
begin
  send(com,c);
end;

procedure tseriell.empfange(var c:char;var stat:byte);
begin
  stat:=recv(com,c);
end;

procedure tseriell.swrite(s:string);
var n:byte;
begin
  for n:=1 to length(s) do begin
    if (s[n]='^') and (length(s)>n) then begin
      sende(char(byte(upcase(s[succ(n)]))-byte(pred('A'))));
      inc(n);
    end else sende(s[n]);
  end;
end;

function tseriell.readcom:string;
var s:string;
    n,zeit,stat:byte;
    c:char;
begin
  n:=0;
  s:='';
  zeit:=0;
  empfange(c,stat);
  if (stat and sttimeout)<>0 then begin
    c:='?';
    inc(zeit);
  end;
  while (n<255) and (zeit<timeout) and (c<>LF) do begin
    if c<>cr then s:=s+c;
    repeat
      empfange(c,stat);
      if (stat and sttimeout)<>0 then inc(zeit);
    until (zeit>Timeout) or ((stat and sttimeout)=0);
  end;
  if zeit>=timeout then begin
    writeln('TimeOut bei READCOM');
    readcom:='';
  end else readcom:=s;
end;

function tseriell.waitfor(s:string):boolean;
var gef,zeit,stat:byte;
    c:char;
begin
  gef:=0;
  zeit:=0;
  while (gef<length(s)) and (zeit<timeout) and (not keypressed) do begin
    empfange(c,stat);
    if (stat and stTimeOut)>0 then inc(zeit)
    else begin
      zeit:=0;
      if c=s[succ(gef)] then inc(gef) else gef:=0;
    end;
  end;
  if zeit>=timeout then waitfor:=erTimeOut else waitfor:=erNone;
  if keypressed then begin
    while keypressed do readkey;
    waitfor:=erTimeOut;
  end;
end;

function tseriell.readtofile(var fil:text;slist:TStringList;anzahl:byte;loggen:boolean):byte;
var puf:string;
    weiter,n:byte;
    zeit,stat,mogl:byte;
    keinsstimmt,einsgefunden,allenull:boolean;
    c:char;
    gef:tgef;
    crlfgef:byte;
begin
  einsgefunden:=false;
  zeit:=0;
  puf:='';
  weiter:=0;
  fillchar(gef,sizeof(gef),#0);
  inc(anzahl);
  slist[anzahl]:=#$d#$d;
  while (weiter=0) and (not keypressed) and (not (zeit>timeout)) do begin
    empfange(c,stat);
    if (stat and stTimeOut)>0 then inc(zeit) else begin
      puf:=puf+c;
      zeit:=0;
      keinsstimmt:=true;
      for n:=1 to anzahl do begin
        if c=slist[n][succ(gef[n])] then begin
          if (not einsgefunden) or (gef[n]<>0) then inc(gef[n]);
          keinsstimmt:=false;
        end else gef[n]:=0;
        if gef[n]>=length(slist[n]) then begin
          gef[n]:=0;
          if n<anzahl then begin
            mogl:=n;
            einsgefunden:=true;
          end;
          puf:='';
        end;
      end;
      if keinsstimmt then begin
        if loggen and (not einsgefunden) then write(fil,puf);
        puf:='';
      end;
      allenull:=true;
      for n:=1 to pred(anzahl) do allenull:=allenull and (gef[n]=0);
      if einsgefunden and allenull then weiter:=mogl;
    end;
  end;
  if keypressed or (zeit>timeout) then weiter:=0;
  while keypressed do readkey;
  readtofile:=weiter; {0=Timeout, i=si}
end;

end.