unit UBuf;
interface
Type PByteArray=^TByteArray;
     TByteArray=array[0..65534] of byte;
     PBuf=^OBuf;
     OBuf=object
       size:word;
       putpos,getpos,aktsize:word;
       buf:pbytearray;
       constructor init(asize:word);
       destructor done;
       procedure put(b:byte);
       function get(var b:byte):boolean;
     end;

implementation

constructor obuf.init(asize:word);
begin
  size:=asize;
  putpos:=0;
  getpos:=0;
  aktsize:=0;
  getmem(buf,asize);
end;

destructor obuf.done;
begin
  freemem(buf,size);
end;

procedure obuf.put(b:byte);
begin
  buf^[putpos]:=b;
  inc(putpos);
  if putpos=size then putpos:=0;
  if aktsize<size then inc(aktsize);
end;

function obuf.get(var b:byte):boolean;
begin
  if aktsize>0 then begin
    asm cli end; {Interrupts sperren}
    b:=buf^[getpos];
    inc(getpos);
    if getpos=size then getpos:=0;
    dec(aktsize);
    asm sti end; {Interrupts freigeben}
    get:=true;
  end else get:=false;
end;

end.